p586
                model flat
locals @@
CODE            segment para public 'CODE' use32

                public start
start           proc near
                push    0
                call    GetModuleHandleA
                mov     Our_Handle, eax

                push    offset a_Hexedit
                call    LoadLibraryA

                call    LoadCSV
                mov     eax, CSV_Buf

                mov     eax, 1
                push    0
                push    offset Dlg_Proc
                push    0
                push    eax
                push    Our_Handle
                call    DialogBoxParamA

                push    0
                call    ExitProcess
start           endp

Dlg_Proc  proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h

                push    ebp
                mov     ebp, esp
                mov     eax, [ebp+arg_0]
                mov     Dlg_hwnd, eax
                mov     eax, [ebp+arg_4]

                cmp     eax, 4Eh
                jz      Notify   ; Proceed minimaze,restore and close events

                cmp     eax, 110h
                jz      Dlg_Init     ; Initialize

                cmp     eax, 111h
                jz      Dlg_Command  ; Proceed DLG events

                cmp     eax, 112h
                jz      SysCommand   ; Proceed minimaze,restore and close events

                cmp     eax,402h
                jz      Dev_Notify

dlg_default:
                xor     eax, eax
                leave
                retn    10h

dlg_exit:
                mov    eax,1
                leave
                retn    10h

;-----------------------------------
;-----------------------------------
;-----------------------------------

Dev_Notify:
                mov     eax, [ebp+arg_8]
                cmp     eax, 1
                jz      Dev_conn
                cmp     eax, 0
                jnz     dev_done
                push    offset str_not_conn
                push    0
                push    401h
                push    1018
                push    Dlg_hwnd
                call    SendDlgItemMessageA
                jmp     dev_done
Dev_Conn:
                push    offset str_conn
                push    0
                push    401h
                push    1018
                push    Dlg_hwnd
                call    SendDlgItemMessageA
dev_done:
                mov     eax, 1
                leave
                retn    10h
;-----------------------------------
;-----------------------------------

Dlg_Command:   ; Proceed DLG events
                mov     eax, [ebp+arg_8]

                cmp     eax, 1004
                jz      bt_ld_seem
                cmp     eax, 1005
                jz      bt_ld_file
                cmp     eax, 1008
                jz      bt_wr_seem
                cmp     eax, 1009
                jz      bt_wr_file
                cmp     eax, 1010
                jz      bt_restart

                cmp     eax, 1020
                jz      bt_bit0
                cmp     eax, 1021
                jz      bt_bit1
                cmp     eax, 1022
                jz      bt_bit2
                cmp     eax, 1023
                jz      bt_bit3
                cmp     eax, 1024
                jz      bt_bit4
                cmp     eax, 1025
                jz      bt_bit5
                cmp     eax, 1026
                jz      bt_bit6
                cmp     eax, 1027
                jz      bt_bit7

                jmp    dlg_exit



bt_ld_seem:
                push    [ebp+arg_0]
                call    Load_Seem
                jmp     dlg_exit

bt_ld_file:
                push    [ebp+arg_0]
                call    Load_File
                jmp     dlg_exit

bt_wr_seem:
                push    [ebp+arg_0]
                call    Write_Seem
                jmp     dlg_exit
bt_wr_file:
                push    [ebp+arg_0]
                call    Write_File
                jmp     dlg_exit

bt_restart:
                cmp     DevFound, 1
                jnz     dlg_exit
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0
                push    offset Cmd_Send_Buf
                push    0022h                  ; RESTART
                call    P2K_SendCommand
                jmp     dlg_exit

;-----------------------------------
;-----------------------------------
SysCommand: ; Proceed minimaze,restore and close events
                mov    eax, [ebp+arg_8]
                cmp    eax, 0F060h ;SC_Close
                jz     Dlg_close
                jmp    dlg_default

;-----------------------------------
;-----------------------------------
;-----------------------------------


Dlg_Init:
                push    offset Thread_ID
                push    0
                push    0
                push    offset DevMonitor_Proc
                push    0
                push    0
                call    CreateThread
                mov     Thread_Handle, eax

                push    1018
                push    [ebp+arg_0]
                push    offset str_not_conn
                push    50000000h ; style
                call    CreateStatusWindowA


                push    offset status_parts
                push    3
                push    404h ; SB_SETPARTS
                push    1018
                push    [ebp+arg_0]
                call    SendDlgItemMessageA

                mov     eax, 1
                leave
                retn    10h

Notify:
                mov    eax, [ebp+arg_C]
                mov    eax,[eax+4]
                cmp    eax, 1001
                jnz    dlg_exit

                push   [ebp+arg_0]
                call   Change_Buf
                jmp    bit_done
bt_bit0:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 01h
                jmp    bit_done
bt_bit1:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 02h
                jmp    bit_done
bt_bit2:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 04h
                jmp    bit_done
bt_bit3:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 08h
                jmp    bit_done
bt_bit4:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 10h
                jmp    bit_done
bt_bit5:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 20h
                jmp    bit_done
bt_bit6:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 40h
                jmp    bit_done
bt_bit7:
                mov    eax, offset seem_buf
                add    eax, Buf_Ofs
                xor    byte ptr [eax], 80h
bit_done:
                push   0
                push   0
                push   403h
                push   1001
                push   [ebp+arg_0]
                call   SendDlgItemMessageA

                push   [ebp+arg_0]
                call   Change_Buf
                jmp    dlg_exit
;-----------------------------------
;-----------------------------------
;-----------------------------------
;-----------------------------------
;-----------------------------------


;------------------------------------
Dlg_close:
                push    0
                push    [ebp+arg_0]
                call    EndDialog
                mov     eax, 1
                leave
                retn    10h


Dlg_Proc  endp

Change_Buf      proc    near
arg_0           = dword ptr  8
                push    ebp
                mov     ebp, esp
                push    esi

                push    0
                push    0
                push    402h
                push    1001
                push    [ebp+arg_0]
                call    SendDlgItemMessageA
                mov     Buf_Ofs, eax
                mov     esi, offset seem_buf
                add     esi, eax

                lodsb
                mov     ecx, 8
;                int 3
@@cb_loop:
                push    ecx
                push    eax
                dec     ecx
                shr     eax, cl
                and     eax, 1
;int 3
                push    Buf_Ofs
                push    ecx
                push    eax
                push    [ebp+arg_0]
                call    UpdateBitComment

                push    0
                push    eax
                push    0F1h
                add     ecx, 1020
                push    ecx
                push    [ebp+arg_0]
                call    SendDlgItemMessageA

                pop     eax
                pop     ecx
                loop    @@cb_loop

                push    Buf_Ofs
                push    Current_Rec
                push    Current_Seem
                call    ReadCSV_Byte
                cmp     eax, 0
                mov     eax, offset str_null
                jnz     @@skip
                mov     eax, offset CSV_Descr
@@skip:
                push    eax
                push    Buf_Ofs
                push    offset str_Byte_ctl
                push    offset str_buf
                call    wsprintfA
                add     esp, 10h

                push    offset str_buf
                push    1017
                push    [ebp+arg_0]
                call    SetDlgItemTextA
                pop     esi
                leave
                retn    4
Change_Buf      endp

UpdateBitComment proc near
arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h

                push    ebp
                mov     ebp, esp

                push    eax
                push    ecx
                push    edx
                push    ebx
                cmp     seem_type,1
                jnz     @@skip_comment
                push    [ebp+arg_8] ; bit
                push    [ebp+arg_C] ; ofs
                push    Current_Rec
                push    Current_Seem
                call    ReadCSV_Bit
                cmp     eax, -1
                jz      @@skip_comment


                cmp     [ebp+arg_4], 0
                jnz     @@val_1
                mov     eax, offset CSV_Val0
                jmp     @@val_done
@@val_1:
                mov     eax, offset CSV_Val1
@@val_done:
                push    eax
                push    offset CSV_Descr
                push    [ebp+arg_8]
                push    offset bit_str
                push    offset str_buf
                call    wsprintfA
                add     esp, 14h
                jmp     @@comment_done

@@skip_comment:

                push    ecx
                push    offset bit_str_0
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch
                jmp     @@comment_done

@@comment_done:
                mov     eax, 1020
                add     eax, [ebp+arg_8]
                push    eax
                push    [ebp+arg_0]
                call    GetDlgItem

                push    offset str_buf
                push    eax
                call    SetWindowTextA

                pop     ebx
                pop     edx
                pop     ecx
                pop     eax
                leave
                retn    10h
UpdateBitComment endp


LoadCSV         proc    near
                push    -1
                push    0
                push    3 ; open existing
                push    0
                push    0
                push    0C0000000h ; generic RW
                push    offset csv_file
                call    CreateFileA
                mov     CSV_FHandle, eax
                cmp     eax, 0
                jz      @@exit_0

                push    offset filesize_ex
                push    eax
                call    GetFileSize
                cmp     filesize_ex, 0
                jnz     @@exit
                mov     CSV_Size, eax

                push    eax
                push    40h
                call    GlobalAlloc
                cmp     eax, 0
                jz      @@exit
                mov     CSV_Buf, eax

                push    0 ; overlapped
                push    offset file_readed ; bytes readen
                push    CSV_Size           ; bytes to read
                push    CSV_Buf
                push    CSV_FHandle
                call    ReadFile
                cmp     eax, 0
                jnz     @@exit

                push    CSV_Buf
                call    GlobalFree
                mov     CSV_Size, 0
                mov     CSV_Buf, 0
@@exit:
                push    CSV_FHandle
                call    CloseHandle
@@exit_0:
                retn
LoadCSV         endp

ReadCSV_Bit         proc    near
arg_0           = dword ptr  8   ; seem
arg_4           = dword ptr  0Ch ; rec
arg_8           = dword ptr  10h ; ofs
arg_C           = dword ptr  14h ; bit

                push    ebp
                mov     ebp, esp
                push    ecx
                push    edx
                push    ebx
                mov     CSV_Pos, 0
@@loop:
                cmp     CSV_Pos, -1
                jz      @@fail
                call    CSV_GetLine

                push    offset CSV_Seem
                call    HexStr2Int
                cmp     eax, [ebp+arg_0]
                jnz     @@loop

                push    offset CSV_Rec
                call    HexStr2Int
                cmp     eax, [ebp+arg_4]
                jnz     @@loop

                push    offset CSV_Ofs
                push    offset str_not0
                call    lstrcmpA
                cmp     eax, 0
                jz      @@loop

                push    offset CSV_Ofs
                call    HexStr2Int
                cmp     eax, [ebp+arg_8]
                jnz     @@loop

                push    offset CSV_Bit
                push    offset str_not0
                call    lstrcmpA
                cmp     eax, 0
                jz      @@loop

                push    offset CSV_Bit
                call    HexStr2Int
                cmp     eax, [ebp+arg_C]
                jnz     @@loop

                mov     eax, 0
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    10h
ReadCSV_Bit     endp

ReadCSV_Byte    proc    near
arg_0           = dword ptr  8   ; seem
arg_4           = dword ptr  0Ch ; rec
arg_8           = dword ptr  10h ; ofs

                push    ebp
                mov     ebp, esp
                mov     CSV_Pos, 0
@@loop:
                cmp     CSV_Pos, -1
                jz      @@fail
                call    CSV_GetLine

                push    offset CSV_Seem
                call    HexStr2Int
                cmp     eax, [ebp+arg_0]
                jnz     @@loop

                push    offset CSV_Rec
                call    HexStr2Int
                cmp     eax, [ebp+arg_4]
                jnz     @@loop

                push    offset CSV_Ofs
                push    offset str_not0
                call    lstrcmpA
                cmp     eax, 0
                jz      @@loop

                push    offset CSV_Ofs
                call    HexStr2Int
                cmp     eax, [ebp+arg_8]
                jnz     @@loop

                push    offset CSV_Bit
                push    offset str_not0
                call    lstrcmpA
                cmp     eax, 0
                jnz     @@loop

                mov     eax, 0
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                leave
                retn    0Ch
ReadCSV_Byte    endp

ReadCSV_Seem    proc    near
arg_0           = dword ptr  8   ; seem
arg_4           = dword ptr  0Ch ; rec

                push    ebp
                mov     ebp, esp
                mov     CSV_Pos, 0
@@loop:
                cmp     CSV_Pos, -1
                jz      @@fail
                call    CSV_GetLine

                push    offset CSV_Seem
                call    HexStr2Int
                cmp     eax, [ebp+arg_0]
                jnz     @@loop

                push    offset CSV_Rec
                call    HexStr2Int
                cmp     eax, [ebp+arg_4]
                jnz     @@loop

                push    offset CSV_Ofs
                push    offset str_not0
                call    lstrcmpA
                cmp     eax, 0
                jnz     @@loop

                push    offset CSV_Bit
                call    HexStr2Int
                mov     seem_type, eax
                mov     eax, 0
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                leave
                retn    8
ReadCSV_Seem    endp

CSV_GetLine     proc    near
                push    esi
                push    ecx
                push    edx
                push    ebx
                xor     eax, eax
                mov     edi, offset CSV_Seem
                mov     ecx, 1C0h
                rep     stosd
                mov     esi, CSV_Buf
                add     esi, CSV_Pos
                mov     edx, 0

@@next_block:
                mov     edi, offset CSV_Seem
                add     edi, edx
                add     edx, 100h
@@loop_str:
                mov     al, [esi]
                inc     esi
                cmp     al, 3Bh
                jz      @@next_block
                cmp     al, 0Dh
                jz      @@done

                cmp     al, 22h
                jnz     @@no_skip

                cmp     byte ptr [esi], 22h
                jnz     @@skip
                inc     esi
@@no_skip:
                mov     [edi], al
                inc     edi
@@skip:
                mov     ecx, esi
                sub     ecx, CSV_Buf
                cmp     ecx, CSV_Size
                jae     @@no_more_csv

                jmp     @@loop_str
@@no_more_csv:
                mov     eax, -1
                mov     CSV_Pos, -1
                jmp     @@exit

@@done:
                cmp     byte ptr [esi], 0Ah
                jnz     @@no_lf
                inc     esi
@@no_lf:
                sub     esi, CSV_Buf
                mov     CSV_Pos, esi
                mov     eax, 0

@@exit:
                pop     ebx
                pop     edx
                pop     ecx
                pop     esi
                retn
CSV_GetLine     endp

HexStr2Int      proc near
arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp
                push    esi
                push    ecx
                push    edx
                mov     ecx,8
                mov     edx,0
                mov     esi, [ebp+arg_0]
@@loop:
                lodsb
                cmp     al, 0
                jz      @@exit
                cmp     al, 30h
                jb      @@exit
                sub     al,30h
                cmp     al, 9
                jbe     @@num
                sub     al, 7
@@num:
                cmp     al, 10h
                jb      @@ok
                sub     al, 20h
@@ok:
                cmp     al, 0fh
                ja      @@exit

                shl     edx, 4
                or      dl, al
                loop    @@loop
@@exit:
                mov     eax, edx
                pop     edx
                pop     ecx
                pop     esi
                leave
                retn 4
HexStr2Int      endp

LogStat         proc near
arg_0           = dword ptr  8
                push    ebp
                mov     ebp, esp
                pusha
                cmp     stay_quiet,1
                jz      @@quiet
;                push    [ebp+arg_0]
;                push    0               ; reserved
;                push    0C2h
;                push    1000
;                push    Dlg_hwnd
;                call    SendDlgItemMessageA
@@quiet:
                popa
                leave
                retn 4
Logstat         endp

;------------- SEEM IO ----------------

Write_File      proc near

arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp

;                cmp     seem_buf_size, 0
;                jz      @@canceled

                push Current_Rec
                push Current_Seem
                push offset str_ctl
                push offset Fname_buf
                call wsprintfA
                add  esp, 10h


                push    offset OpenFileNameSize
                mov     OFN_Flags, 0
                call    GetSaveFileNameA
                cmp     eax, 0
                jz      @@canceled

                push    -1
                push    0
                push    2 ; Create new
                push    0
                push    0
                push    0C0000000h ; generic RW
                push    offset Fname_buf
                call    CreateFileA
                mov     FHandle, eax

                push    0
                push    offset file_readed
                push    seem_buf_size
                push    offset seem_buf
                push    FHandle
                call    WriteFile

                push    FHandle
                call    CloseHandle
@@canceled:
                leave
                retn 4
Write_File      endp

Load_File       proc near

arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp


; Seem no
                push    10h
                push    offset str_buf
                push    1002
                push    [ebp+arg_0]
                call    GetDlgItemTextA

                push    offset str_buf
                call    HexStr2Int
                cmp     eax,0FFFFh
                jb      @@seem_ok
                mov     eax, 0FFFFh
@@seem_ok:
                mov     seem_no, eax
                mov     Current_Seem, eax
                push    eax
                push    offset str_hexdw
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch

                push    offset str_buf
                push    1002
                push    [ebp+arg_0]
                call    SetDlgItemTextA

                push    offset str_buf
                push    1006
                push    [ebp+arg_0]
                call    SetDlgItemTextA

; Rec no
                push    10h
                push    offset str_buf
                push    1003
                push    [ebp+arg_0]
                call    GetDlgItemTextA

                push    offset str_buf
                call    HexStr2Int

                cmp     eax,0FFFFh
                jb      @@rec_ok1
                mov     eax, 1h
@@rec_ok1:
                cmp     eax,0
                ja      @@rec_ok
                mov     eax, 1h
@@rec_ok:
                mov     rec_no, eax
                mov     Current_Rec, eax
                push    eax
                push    offset str_hexdw
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch

                push    offset str_buf
                push    1003
                push    [ebp+arg_0]
                call    SetDlgItemTextA

                push    offset str_buf
                push    1007
                push    [ebp+arg_0]
                call    SetDlgItemTextA

; get seem size
                mov     fname_buf, 0
                mov     fname_t_buf, 0
                mov     OFN_Flags, 0
                push    offset OpenFileNameSize
                call    GetOpenFileNameA

                push    -1
                push    0
                push    3 ; open existing
                push    0
                push    0
                push    0C0000000h ; generic RW
                push    offset fname_buf
                call    CreateFileA
                mov     FHandle, eax
                cmp     eax,-1
                jz      @@fail

                push    offset filesize_ex
                push    eax
                call    GetFileSize
                cmp     filesize_ex, 0
                jnz     @@fail
                mov     seem_buf_size, eax

                push    0 ; overlapped
                push    offset file_readed ; bytes readen
                push    seem_buf_size  ; bytes to read
                push    offset seem_buf
                push    FHandle
                call    ReadFile
                cmp     eax, 0
                jz      @@fail
                mov     eax, seem_buf_size
                cmp     file_readed, eax
                jnz     @@fail

                push    FHandle
                call    CloseHandle

                call    UpdateSeem
@@fail:
                leave
                retn 4
Load_File       endp

Write_Seem   proc near

arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp
                cmp     DevFound,1
                jz      @@ok
                push    0
                push    0
                push    offset str_not_conn
                push    0
                call    MessageBoxA
                jmp     @@fail
@@ok:

; get seem size
                push    4
                push    offset str_Wairning
                push    offset str_WriteSeem
                push    0
                call    MessageBoxA
                cmp     eax, 6
                jnz     @@fail
                push    offset str_buf
                push    0
                push    0
                push    Current_Rec
                push    Current_Seem
                call    Cmd_RDELEM
                cmp     eax, 0
                jnz     @@fail
                cmp     byte ptr str_buf, 0
                jnz     @@fail
                mov     eax, seem_read_bytes
                dec     eax
                cmp     eax, seem_buf_size
                jnz     @@fail

                push    ecx
                push    esi
                push    edi

                mov     esi, offset seem_buf
                mov     edi, offset seem_data
                mov     ecx, seem_buf_size
                rep     movsb

                pop     edi
                pop     esi
                pop     ecx

                push    seem_buf_size
                push    0
                push    rec_no
                push    seem_no
                call    Cmd_STELEM
                cmp     eax, 0
                jnz     @@fail
@@fail:
                leave
                retn 4

Write_Seem      endp


Load_Seem       proc near

arg_0           = dword ptr  8
                push    ebp
                mov     ebp, esp
                cmp     DevFound,1
                jz      @@ok
                push    0
                push    0
                push    offset str_not_conn
                push    0
                call    MessageBoxA
                jmp     @@exit
@@ok:

; Seem
                push    10h
                push    offset str_buf
                push    1002
                push    [ebp+arg_0]
                call    GetDlgItemTextA

                push    offset str_buf
                call    HexStr2Int
                cmp     eax,0FFFFh
                jb      @@seem_ok
                mov     eax, 0FFFFh
@@seem_ok:
                mov     seem_no, eax
                mov     Current_Seem, eax
                push    eax
                push    offset str_hexdw
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch

                push    offset str_buf
                push    1002
                push    [ebp+arg_0]
                call    SetDlgItemTextA

                push    offset str_buf
                push    1006
                push    [ebp+arg_0]
                call    SetDlgItemTextA

; Rec
                push    10h
                push    offset str_buf
                push    1003
                push    [ebp+arg_0]
                call    GetDlgItemTextA

                push    offset str_buf
                call    HexStr2Int
                cmp     eax,0FFFFh
                jb      @@rec_ok
                mov     eax, 0FFFFh
@@rec_ok:
                mov     rec_no, eax
                mov     Current_Rec, eax
                push    eax
                push    offset str_hexdw
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch

                push    offset str_buf
                push    1003
                push    [ebp+arg_0]
                call    SetDlgItemTextA

                push    offset str_buf
                push    1007
                push    [ebp+arg_0]
                call    SetDlgItemTextA

                push    offset seem_stat
                push    0
                push    0
                push    rec_no
                push    Seem_no
                call    Cmd_RDELEM
                cmp     eax, 0
                jnz     @@exit
                cmp     byte ptr seem_stat, 0
                jnz     @@exit

                mov     eax, seem_read_bytes
                dec     eax
                mov     seem_buf_size, eax

                call    UpdateSeem
@@exit:
                leave
                retn    4
Load_Seem       endp

UpdateSeem      proc    near
                push    seem_buf_size
                push    offset seem_buf
                push    0401h
                push    1001
                push    [ebp+arg_0]
                call    SendDlgItemMessageA

                push    1001
                push    [ebp+arg_0]
                call    GetDlgItem
                push    eax
                call    SetFocus

                push   0
                push   0
                push   403h
                push   1001
                push   [ebp+arg_0]
                call   SendDlgItemMessageA

                push    Current_Rec
                push    Current_Seem
                call    ReadCSV_Seem
                cmp     eax, 0
                jnz     @@fail

                push    offset CSV_Val1
                push    offset CSV_Descr
                push    Current_Rec
                push    Current_Seem
                push    offset str_seem_ctl
                push    offset str_buf
                call    wsprintfA
                add     esp, 18h

                push    offset str_buf
                push    1016
                push    [ebp+arg_0]
                call    SetDlgItemTextA

                push    [ebp+arg_0]
                call    Change_Buf

@@fail:
                retn
UpdateSeem      endp

Cmd_RDELEM      proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h
arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp

                push    ebx
                push    esi
                push    edi

                mov     eax, [ebp+arg_0] ; seem
                xchg    al, ah
                mov     seem_num, ax

                mov     eax, [ebp+arg_4] ; record
                xchg    al, ah
                mov     seem_rec, ax

                mov     eax, [ebp+arg_8] ; ofs
                xchg    al, ah
                mov     seem_ofs, ax

                mov     eax, [ebp+arg_C] ; bytes
                xchg    al, ah
                mov     seem_bytes, ax


                mov     seem_read_bytes, 1

                push    offset seem_read_bytes
                push    [ebp+arg_10]

                push    8                     ; DataBuf size
                push    offset seem_num

                push    020h           ; COMMAND - RDELEM
                call    P2K_SendCommand
                test    eax, eax
                jnz     @@fail
                mov     eax, 0
                mov     ecx, seem_read_bytes
                cmp     seem_read_bytes, 0
                jbe     short @@ok
                mov     edi, [ebp+arg_10]
                mov     bl, [edi]
                test    bl, bl
                jz      short @@ok
@@fail:
                mov     eax, -1
@@ok:
                pop     edi
                pop     esi
                pop     ebx
                leave
                retn    14h
Cmd_RDELEM      endp

Cmd_STELEM      proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h

                push    ebp
                mov     ebp, esp

                push    ebx
                push    esi
                push    edi

                mov     eax, [ebp+arg_0] ; seem
                xchg    al, ah
                mov     seem_num, ax

                mov     eax, [ebp+arg_4] ; record
                xchg    al, ah
                mov     seem_rec, ax

                mov     eax, [ebp+arg_8] ; ofs
                xchg    al, ah
                mov     seem_ofs, ax

                mov     eax, [ebp+arg_C] ; bytes
                cmp     eax,0
                ja      @@size_nz
                mov     eax,1
@@size_nz:
                cmp     eax, 2710h
                jna     @@zize_ok
                mov     eax, 2710h
@@zize_ok:
                mov     [ebp+arg_C], eax
                xchg    al, ah
                mov     seem_bytes, ax


                mov     seem_read_bytes, 1

                push    offset seem_read_bytes
                push    offset stelem_result

                mov     eax, [ebp+arg_C] ; bytes
                add     eax, 8
                push    eax                   ; DataBuf size
                push    offset seem_num

                push    02Fh        ; COMMAND STELEM
                call    P2K_SendCommand
                test    eax, eax
                jnz     @@fail
                mov     eax, 0
                mov     bl, byte ptr stelem_result
                test    bl, bl
                jz      short @@ok
@@fail:
                mov     eax, -1
@@ok:
                pop     edi
                pop     esi
                pop     ebx
                leave
                retn    10h
Cmd_STELEM      endp










;------------- P2K USB IO Procedures ----------------


DevMonitor_Proc proc near
@@init_fail:
                push    3E8h
                call    Sleep
                call    COM_Find
                cmp     eax, 0
                jnz     @@no_comm
                call    Switch_mode
                push    1388h
                call    Sleep
@@no_comm:
                call    FindUSBClass
                cmp     _DevIF, 0
                jz      @@init_fail
                mov     DevFound, 1

                push    0
                push    1
                push    402h
                push    Dlg_hwnd
                call    SendMessageA

                mov     eax, Dev_Name_Ptr
                add     eax, 4
                push    eax
                push    offset str_devclass_key
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch
                mov     byte ptr [str_buf+56h], '#'
                mov     byte ptr [str_buf+57h], '#'
                mov     byte ptr [str_buf+59h], '#'

                push    offset Key_Class_handle  ; handle
                push    20019h         ; access mask
                push    0              ; res
                push    offset str_buf ; subkey
                push    80000002h      ; key
                call    RegOpenKeyExA

                push    0 ; async flag
                push    0; Key_Event
                push    5 ;notify filter - name+last_set
                push    1 ; flag subkey notify
                push    Key_Class_handle
                call    RegNotifyChangeKeyValue

                push    Key_Class_handle
                call    RegCloseKey

                push    _DevIF
                call    CloseHandle

                push    Dev_Name_Ptr
                call    GlobalFree

                mov     DevFound, 0
                mov     _DevIF, 0

                push    0
                push    0
                push    402h
                push    Dlg_hwnd
                call    SendMessageA

                push    1388h
                call    Sleep
                jmp     @@init_fail
DevMonitor_Proc endp



P2K_SendCommand proc near
arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h
arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp

                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
                inc     Packet_ID

                mov     edi, offset packet_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     edi, offset packet_buf
                mov     byte ptr [edi+00h], 41h
                mov     byte ptr [edi+01h], 02h
                mov     word ptr [edi+02h], 0000h
                mov     word ptr [edi+04h], 0008h ; Interface
                mov     eax, [ebp+arg_8]
                add     eax, 8
                mov     word ptr [edi+06h], ax    ; size ws command & size
                mov     dx, Packet_ID
                and     dx, 0FFFh
                xchg    dh, dl
                mov     word ptr [edi+08h], dx ; random - Packet ID
                mov     edx, [ebp+arg_0]
                and     dx,0FFFh
                xchg    dh,dl
                mov     word ptr [edi+0Ah], dx ; command
                mov     eax, [ebp+arg_8]
                xchg    ah, al
                mov     word ptr [edi+0Ch], ax    ; size
                mov     word ptr [edi+0Eh], 0000h
                mov     eax, [ebp+arg_8]
                add     eax, 12h
                mov     packet_size, eax
                mov     esi, [ebp+arg_4]
                add     edi, 10h
                mov     ecx, [ebp+arg_8]
                rep     movsb

                push    offset packet_size
                push    offset packet_buf
                call    USB_WriteData
                cmp     eax, 0
                jz      @@Write_ok

                push    offset msg_cmd_write_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit

@@Write_ok:
                call    GetTickCount
                mov     ReadStatus_Ticks, eax
@@status_loop:
                mov     edi, offset status_read_buf
                mov     ecx, 3
                xor     eax, eax
                rep     stosd

                mov     edi, offset status_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 0
                mov     word ptr [edi+02h], 0
                mov     word ptr [edi+04h], 8
                mov     word ptr [edi+06h], 8

                mov     status_read_size, 0Ch

                push    offset status_read_size
                push    offset status_read_buf
                call    USB_ReadData

                cmp     eax, 0
                jnz     @@next_try
                mov     al, status_read_buf+1
                cmp     al, 3
                jae     @@next_try
                cmp     al, 0
                jnz     @@done
@@next_try:
                push    1
                call    Sleep

                call    GetTickCount
                sub     eax, ReadStatus_Ticks
                cmp     eax, 9C40h ; timeout
                jb      @@status_loop

                push    offset msg_cmd_timeout
                mov     eax,-1
                jmp     @@exit

@@done:
                push    1
                call    Sleep

                mov     edi, offset data_read_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     edi, offset data_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 1
                movzx   ax, byte ptr status_read_buf+1
                mov     word ptr [edi+02h], ax ; packets #
                mov     word ptr [edi+04h], 8 ; IF

                shl     ax, 1
                mov     cx, word ptr status_read_buf+2
                xchg    ch, cl
                add     ax, cx
;                add     ax, word ptr status_read_buf+4
;                add     ax, word ptr status_read_buf+6
                add     ax, 4
                mov     word ptr [edi+06h], ax ; Size

                mov     data_read_size, 0FA4h
                push    offset data_read_size
                push    offset data_read_buf
                call    USB_ReadData
                cmp     eax, 0
                jz      @@Read_ok

                push    offset msg_cmd_read_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@Read_ok:
                mov     esi, offset data_read_buf
                cmp     byte ptr [esi+00h], 1
                jnz     @@fail
                mov     cx, [esi+04h]
                xchg    ch,cl
                mov     dl, [esi+06h]
                and     dl, 80h
                cmp     dl, 80h
                jnz     @@fail
                mov     dx, [esi+06h]
                xchg    dh, dl
                and     dx, 0FFFh ; Packet ID
                cmp     Packet_ID, dx
                jnz     @@fail
                mov     dl, [esi+08h]
                shr     dl, 4

                cmp     dl, 6        ; Answ 6 - result ok, no data returned
                mov     eax, 0
                jz      @@exit

                cmp     dl, 8        ; Answ 8 - result ok
                jz      @@op_ok
                and     edx, 0Fh
                mov     eax, [IO_Err+edx*4]
                push    eax
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@op_ok:
                mov     dx, [esi+0Ah]
                xchg    dh, dl
                sub     cx, 8
                cmp     cx, dx
                jnz     @@fail ; bad packet - size mismatch
                jmp     @@ok

@@fail:
                push    offset msg_cmd_answer_fail
                call    logstat
                mov     eax, 1
                jmp     @@exit

@@ok:
                add     esi, 0Eh
                mov     edi, [ebp+arg_C]
                mov     eax, [ebp+arg_10]
                and     ecx, 0FFFFh
                mov     [eax], ecx
                rep     movsb
                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    14h
P2K_SendCommand endp

USB_WriteData   proc    near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

                push    offset msg_usb_event_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_reset_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                push    offset DevIO_Overlapped
                push    0
                push    5
                push    offset DevIO_Result
                mov     eax,[ebp+arg_4] ; InBuf_Size
                mov     eax, [eax]
                push    eax
                push    [ebp+arg_0]     ; InBuf
                push    80002014h
                push    _DevIF
                call    DeviceIOControl

                push    3E8h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    _DevIF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_wait_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:
                push    0
                push    [ebp+arg_4] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    _DevIF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    _DevIF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_result_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit

@@devio_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_write_ok
;                call    logstat
                mov     eax, 0
@@exit:
                leave
                retn    8
USB_WriteData   endp

USB_ReadData    proc    near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

                push    offset msg_usb_event_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_reset_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                push    offset DevIO_Overlapped
                push    0
                push    1005h
                push    offset DevIO_Result
                mov     eax,[ebp+arg_4] ; InBuf_Size
                push    9
                push    [ebp+arg_0]     ; InBuf
                push    80002014h
                push    _DevIF
                call    DeviceIOControl

                push    9C40h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    _DevIF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_wait_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    [ebp+arg_4] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    _DevIF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    _DevIF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_result_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                mov     esi, [ebp+arg_4]
                mov     ecx, [esi]
                cmp     ecx, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_size_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                sub     ecx, 4
                mov     [esi], ecx
                mov     esi, offset DevIO_Result
                add     esi, 4
                mov     edi, [ebp+arg_0]
                rep     movsb
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     eax, 0
@@exit:
                leave
                retn    8
USB_ReadData    endp

USB_GetIFInfo   proc    near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp

                push    ecx
                push    esi
                push    edi

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

                push    offset msg_usb_event_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_reset_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:
                mov     eax, [ebp+arg_0]
                mov     IF_Info_cmd, eax

                push    offset DevIO_Overlapped
                push    offset IF_Info_recvd
                push    105h
                push    [ebp+arg_4]
                push    2
                push    offset IF_Info_cmd ; InBuf
                push    80002010h
                push    _DevIF
                call    DeviceIOControl

                push    1388h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    _DevIF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_wait_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    offset IF_Info_recvd ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    _DevIF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    _DevIF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_result_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                cmp     IF_Info_recvd, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
                push    offset msg_usb_size_fail
                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     ecx, dword ptr str_buf
                mov     esi, offset str_buf+4
                mov     edi, offset str_buf
@@str_loop:
                lodsw
                stosb
                loop    @@str_loop

                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ecx
                leave
                retn    8
USB_GetIFInfo   endp


;------------- Phone initialize procs ----------------
COM_Find        proc near
                push    ebp
                mov     ebp, esp
                push    edi
                push    ecx

                mov     edi, offset keyval_buf
                mov     ecx, 40h
                xor     eax, eax
                rep     stosd

                push    offset Key_handle
                push    20019h
                push    0
                push    offset str_serialcom_key
                push    80000002h
                call    RegOpenKeyExA

                mov     keyval_size, 100h

                push    offset keyval_size
                push    offset keyval_buf
                push    offset keyval_type
                push    0
                push    offset str_usbser
                push    Key_handle
                call    RegQueryValueExA

                push    Key_handle
                call    RegCloseKey
                mov     eax, dword ptr keyval_buf
                and     eax, 00FFFFFFh
                cmp     eax, 'MOC'
                jnz     @@fail
                mov     eax, 0
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     edi
                leave
                retn
COM_Find        endp

Switch_mode     proc near
                push    ebp
                mov     ebp, esp

                push    -1
                push    0
                push    1 ; Create new
                push    0
                push    0
                push    0C0000000h ; generic RW
                push    offset keyval_buf
                call    CreateFileA
                mov     ComHandle, eax
                cmp     eax,0
                jnz     @@create_ok
                mov     eax, -1
                jmp     @@exit
@@create_ok:
                push    0
                push    offset at_readed
                push    0Bh
                push    offset at_mode
                push    ComHandle
                call    WriteFile
                cmp     eax, 0
                jnz     @@write_ok
                push    ComHandle
                call    CloseHandle
                mov     eax, -1
                jmp     @@exit
@@write_ok:
                push    ComHandle
                call    CloseHandle
                mov     eax, 0
@@exit:
                leave
                retn
Switch_mode     endp

FindUSBClass    proc near
                push    ebp
                mov     ebp, esp
                pusha

                push    12h             ; flags
                push    0               ; parent_hwnd
                push    0               ; enum
                push    offset DevClass ; class GUID
                call    SetupDiGetClassDevsA
                cmp     eax, -1
                jz      @@getclass_fail
                mov     ClassInfoSet, eax

                mov     DevIF_Index, 0

@@loop:
                mov     _DevIF, 0
                push    offset DevIF_Data   ; DevIFData
                push    DevIF_Index         ; dev index
                push    offset DevClass     ; IF class GUID
                push    0                   ; dev info data
                push    ClassInfoSet
                mov     DevIF_Data, 1Ch     ; size
                call    SetupDiEnumDeviceInterfaces
                test    eax, eax
                jz      @@exit ; @@dev_enum_failed ; +

                push    0                    ; DevInfoData
                push    offset DevIF_ReqSize ; ReqSize
                push    0                    ; DevIFDetailSize
                push    0                    ; DevIFDetail
                push    offset DevIF_Data    ; DevIFData
                push    ClassInfoSet
                call    SetupDiGetDeviceInterfaceDetailA
                test    eax, eax
                jnz     @@dev_info_noerr

                call    GetLastError
                cmp     eax, 7Ah        ; err_insuff_buffer
                jnz     @@exit ; _Destroy_list

@@dev_info_noerr:
                push    DevIF_ReqSize ; 5Ah?
                push    40h
                call    GlobalAlloc
                mov     esi, eax
                test    esi, esi
                jz      @@exit ; _Destroy_list

                mov     dword ptr [esi], 5
                push    0               ; DevInfoData
                push    0               ; DevIF_Req_Size
                push    DevIF_ReqSize   ; DevIFDetailSize
                push    esi             ; DevIFDetail - dd size and str - path
                push    offset DevIF_Data ; DevIFData
                push    ClassInfoSet    ; devinfoset
                call    SetupDiGetDeviceInterfaceDetailA
                test    eax, eax
;                jz      @@Dev_GetDetail_failed
                jz      @@fail_gonext

                push    0
                push    0
                push    3
                push    0
                lea     edi, [esi+4]    ; DevIF path
                push    3
                push    0C0000000h
                push    edi
                call    CreateFileA
                mov     ebx, eax
                cmp     ebx, 0FFFFFFFFh
                jz      short @@fail_gonext
                mov     _DevIF, ebx

                push    offset str_buf
                push    0002h
                call    USB_GetIFInfo

                push    offset str_Motorola_TCI
                push    offset  str_buf
                call    lstrcmpA
                cmp     eax, 0
                jnz     @@not_tci
;                push    edi
;                mov     eax, DevIF_Index
;                mov     [NamesArr_Buf+eax*4], esi
                mov     Dev_Name_Ptr, esi
                jmp     @@exit
@@not_tci:
                push    ebx
                call    CloseHandle
                inc     DevIF_Index
                jmp     @@loop

@@fail_gonext:
                push    esi
                call    GlobalFree
                inc     DevIF_Index
                jmp     @@loop

;@@dev_enum_failed:
;                call    GetLastError
;                jmp     @@exit_Destroy_list

;@@Dev_GetDetail_failed:
;                push    esi
;                call    GlobalFree

@@exit:
                push    ClassInfoSet
                call    SetupDiDestroyDeviceInfoList
@@getclass_fail:
                popa
                leave
                retn
FindUSBClass    endp



CODE            ends

DATA            segment para public 'DATA' use32
Our_Handle      dd 0
Dlg_hwnd        dd 0
hwnd_HexEdit    dd 0

CSV_FHandle     dd 0
filesize_ex     dd 0
file_readed     dd 0
CSV_Size        dd 0
CSV_Buf         dd 0
CSV_Pos         dd 0

Buf_Ofs         dd 0

status_parts    dd 50h, 100h, -1


align 4

a_Hexedit       db 'HexEdit.dll', 0
HexEdit_Class   db 'HexEdit', 0
bit_str         db 'Bit %x - %s - %s', 0
bit_str_0       db 'Bit %x', 0

str_seem_ctl    db 'Seem %.4x Record %.4x', 0Dh, 0Ah
                db '%s', 0Dh, 0Ah
                db '%s', 0

str_null        db 0

csv_file        db 'Functions.csv', 0
str_not0        db '-1', 0
str_Byte_ctl    db 'Offset: %.4x %s', 0
align 4

OpenFileNameSize  dd 4Ch ;    DWORD         lStructSize;
                  dd 0   ;    HWND          hwndOwner;
                  dd 0   ;    HINSTANCE     hInstance;
ofn_filter        dd offset str_ofn_filter   ;    LPCTSTR       lpstrFilter;
                  dd 0   ;    LPTSTR        lpstrCustomFilter;
                  dd 0   ;    DWORD         nMaxCustFilter;
                  dd 0   ;    DWORD         nFilterIndex;
                  dd offset fname_buf       ;    LPTSTR        lpstrFile;
                  dd 1FFh                   ;    DWORD         nMaxFile;
                  dd offset fname_t_buf     ;    LPTSTR        lpstrFileTitle;
                  dd 1FFh                   ;    DWORD         nMaxFileTitle;
                  dd 0   ;    LPCTSTR       lpstrInitialDir;
                  dd 0   ;    LPCTSTR       lpstrTitle;
OFN_Flags         dd 0   ;    DWORD         Flags;
                  dd 0
                         ;    WORD          nFileOffset;
                         ;    WORD          nFileExtension;
                  dd 0   ;    LPCTSTR       lpstrDefExt;
                  dd 0   ;    DWORD         lCustData;
                  dd 0   ;    LPOFNHOOKPROC lpfnHook;
                  dd 0   ;    LPCTSTR       lpTemplateName;

stay_quiet      dd 0

Thread_Handle    dd 0
Thread_Id        dd 0
Key_Class_handle dd 0
DevFound         dd 0

; PSTGetDeviceInterface data
_DevIF          dd 0

IO_Err          dd offset msg_inv_data_len
                dd offset msg_inv_seq
                dd offset msg_cmd_par_inv
                dd offset msg_cmd_not_supp
                dd offset msg_inv_opcode
                dd offset msg_inv_param
                dd offset msg_err_code_unk_6 ; resp_ack
                dd offset msg_generic_fail
                dd offset msg_err_code_unk_8
                dd offset msg_err_code_unk_9
                dd offset msg_mem_fail
                dd offset msg_task_error
                dd offset msg_task_timeout
                dd offset msg_cdma_err
                dd offset msg_len_error
                dd offset msg_crit_error

str_ofn_filter  db 'All files', 0
                db '*.*', 0
                db 'seem file', 0
                db '*.seem', 0, 0

crlf            db 0Dh,0Ah,0
str_ctl         db '%.4x_%.4x.seem', 0
str_hex         db '%x', 0
str_hexdw       db '%.4x', 0
str_dec         db '%d', 0

str_motorola_tci db 'Motorola Test Command',0
str_seem_fn     db 'xxxx_yyyy.seem', 0
str_serialcom_key db 'HARDWARE\DEVICEMAP\SERIALCOMM',0
str_devclass_key  db 'SYSTEM\CurrentControlSet\Control\DeviceClasses\{4e1e1e15-52d7-11d4-852d-00105aa6f80b}\%s\#\Control',0
str_usbser        db '\Device\USBSER000', 0
at_mode           db 'at+mode=8', 0Dh, 0Ah, 0

msg_inv_data_len db 'INVALID DATA LENGTH FOR COMMAND', 0Dh, 0Ah, 0
msg_inv_seq      db 'INADEQUATE SEQURITY LEVEL FOR COMMAND/PARAMETER', 0Dh, 0Ah, 0
msg_cmd_par_inv  db 'COMMAND/PARAMETER NOT SUPPORTED FOR CURRENT PROTOCOL', 0Dh, 0Ah, 0
msg_cmd_not_supp db 'COMMAND NOT SUPPORTED FOR CURRENT MODE', 0Dh, 0Ah, 0
msg_inv_opcode   db 'UNSUPPORTED/INVALID OPCODE', 0Dh, 0Ah, 0
msg_inv_param    db 'UNSUPPORTED/INVALID PARAMETER FOR OPCODE', 0Dh, 0Ah, 0
msg_err_code_unk_6 db 'CRITICAL ERROR - ERROR CODE NOT FOUND (6)', 0Dh, 0Ah, 0
msg_generic_fail db 'GENERIC FAILURE', 0Dh, 0Ah, 0
msg_err_code_unk_8 db 'CRITICAL ERROR - ERROR CODE NOT FOUND (8)', 0Dh, 0Ah, 0
msg_err_code_unk_9 db 'CRITICAL ERROR - ERROR CODE NOT FOUND (9)', 0Dh, 0Ah, 0
msg_mem_fail     db 'COULDN''T ALLOCATE MEMORY', 0Dh, 0Ah, 0
msg_task_error   db 'INTERNAL TASK ERROR', 0Dh, 0Ah, 0
msg_task_timeout db 'TEST COMMAND TASK TIMED OUT WAITING FOR RESPONSE', 0Dh, 0Ah, 0
msg_cdma_err     db 'CDMA PARSE ERROR', 0Dh, 0Ah, 0
msg_len_error    db 'LENGTH SPECIFIED IN COMMAND HEADER GREATER THAN RECEIVED BY TRANSPORT', 0Dh, 0Ah, 0
msg_crit_error   db 'IRRECOVERABLE ERROR; PHONE STATE HAS BEEN LOST. PHONE BEING POWERED DOWN', 0Dh, 0Ah, 0

str_saveseem     db 'downloading seem data from ', 0
str_loadseem     db 'uploading seem N ', 0
str_rec          db 'record N ', 0
str_to           db ' to ', 0
str_wait         db 'Please wait, it can take few minutes...', 0Dh, 0Ah, 0
str_done         db 'Done.', 0Dh, 0Ah, 0


msg_cmd_write_fail  db 'CMD: Data write fail!', 0Dh, 0Ah, 0
msg_cmd_timeout     db 'CMD: Answer wait timeout!', 0Dh, 0Ah, 0
msg_cmd_read_fail   db 'CMD: Data read fail!', 0Dh, 0Ah, 0
msg_cmd_answer_fail db 'CMD: Answer packet invalid!', 0Dh, 0Ah, 0

msg_usb_write_ok    db 'USB: Write data ok', 0Dh, 0Ah, 0
msg_usb_read_ok     db 'USB: Read data ok', 0Dh, 0Ah, 0
msg_usb_event_fail  db 'USB: Event create failed!', 0Dh, 0Ah, 0
msg_usb_reset_fail  db 'USB: Event reset failed!', 0Dh, 0Ah, 0
msg_usb_wait_fail   db 'USB: IO Time-out!', 0Dh, 0Ah, 0
msg_usb_result_fail db 'USB: IO Failed!', 0Dh, 0Ah, 0
msg_usb_size_fail   db 'USB: Answer size invlid!', 0Dh, 0Ah, 0


str_not_conn    db 'Not connected', 0
str_conn        db 'Connected', 0
str_ok          db ' ok', 0Dh, 0Ah, 0
str_fail        db ' Fail!', 0Dh, 0Ah, 0
str_Wairning    db 'Warning', 0
str_WriteSeem   db 'Are you shure you want write seem to phone?' ,0

                align 4

; SetupUI data structures

Dev_Name_Ptr    dd 0

ClassInfoSet    dd 0
DevIF_Index     dd 0

DevIF_Data      dd 0 ; size
DevIF_GUID      dd 0
DevIF_Flags     dd 0
DevIF_res       dd 0
                dd 0
                dd 0
                dd 0


DevIF_ReqSize   dd 0

DevClass        dd 4E1E1E15h, 11D452D7h, 10002D85h, 0BF8A65Ah

DevIO_Overlapped  dd 0
                  dd 0
                  dd 0
                  dd 0
DevIO_Event       dd 0
DevIO_Result      db 1010h dup (?) ; 1008h
;-----------------------------
CommTimeouts       dd ?
CommTimeouts_Multi dd ?
CommTimeouts_Const dd ?
CommTimeouts_W_Multi dd ?
CommTimeouts_W_Const dd ?

ComHandle       dd ?
at_readed       dd ?
Key_handle      dd ?
keyval_type     dd ?
keyval_size     dd ?
keyval_buf      db 100h dup (?)


Cmd_Send_Size    dd ?
Cmd_Recv_Size    dd ?
Cmd_Send_Buf     db 1000h dup (?)
Cmd_Recv_Buf     db 1000h dup (?)

Packet_ID        dw ?
                 dw ?
packet_size      dd ?
packet_buf       db 1000h dup (?)
status_read_size dd ?
status_read_buf  db 0Ch dup (?) ; 0Ch bytes
data_read_size   dd ?
data_read_buf    dd 1000h dup (?)
ReadStatus_Ticks dd ?

IF_Info_cmd      dd ?
IF_Info_recvd    dd ?

CSV_Seem        db 100h dup (?)
CSV_Rec         db 100h dup (?)
CSV_Ofs         db 100h dup (?)
CSV_Bit         db 100h dup (?)
CSV_Descr       db 100h dup (?)
CSV_Val1        db 100h dup (?)
CSV_Val0        db 100h dup (?)

str_buf         db 800h dup (?)

stelem_result   dd ?
seem_read_bytes dd ?

seem_num        dw ?
seem_rec        dw ?
seem_ofs        dw ?
seem_bytes      dw ?
seem_data       db 2710h dup (?)

rec_no          dd ?
seem_no         dd ?
align 4
                db 3 dup (?)
seem_stat       db ?
seem_buf        db 1000h dup (?)
seem_buf_size   dd ?
seem_type       dd ?

Current_Seem    dd ?
Current_Rec     dd ?


FHandle         dd ?
fname_buf       db 200h dup (?) ; buffer for open/save full filename
fname_t_buf     db 200h dup (?) ; buffer for open/save short filename (w/o path)


DATA            ends

include externs.inc
                end start
